﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace S02INxSample
{
    public partial class Form1 : Form
    {
        private short DevId;                     //Device Id
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int id;
            //IdNumコンボボックスにリストを作成
            for (id = 0; id < 16; id++)
                IdNum.Items.Add(id.ToString("X"));//16進で表現
            IdNum.SelectedIndex = 0;//idを0とする
            PictureBox1.Image = ImageList1.Images[0];//状態表示ランプは消灯表示
            PictureBox2.Image = ImageList1.Images[0];
        }

        //デバイスのオープンクローズ
        private void OpenCloseBtn_Click(object sender, EventArgs e)
        {
            short retErr;
            if (OpenCloseBtn.Text == "DeviceOpen")//Openの場合
            {
                DevId = (short)IdNum.SelectedIndex;
                retErr = TUSBSIN.Tusbs02in_Device_Open(DevId);//Open
                if (retErr == 0)
                {
                    Timer1.Interval = 100; //タイマー100ミリ秒毎
                    Timer1.Enabled = true; //タイマーイネーブル
                    IdNum.Enabled = false; //コンボボックスを操作不可にする
                    OpenCloseBtn.Text = "DeviceClose";
                }
                else
                    MessageBox.Show(TUSBSIN.GetErrMessage(retErr));
            }
            else//Closeの場合
            {
                Timer1.Enabled = false; //タイマー停止
                TUSBSIN.Tusbs02in_Device_Close(DevId);//Closeする
                IdNum.Enabled = true;//コンボボックスを操作可にする
                OpenCloseBtn.Text = "DeviceOpen";
            }
        }

        private void Timer1_Tick(object sender, EventArgs e)
        {
            byte in1;
            byte in2;
            short retErr;

            retErr = TUSBSIN.Tusbs02in_Read(DevId, out in1, out in2);//入力状態の読み込み
            if (retErr == 0)
            {
                PictureBox1.Image = (in1 == 0) ? ImageList1.Images[0] : ImageList1.Images[1];
                PictureBox2.Image = (in2 == 0) ? ImageList1.Images[0] : ImageList1.Images[1];
            }
            else
            {
                Timer1.Enabled = false;//
                TUSBSIN.Tusbs02in_Device_Close(DevId);//Closeする
                IdNum.Enabled = true;//コンボボックスを操作可にする
                OpenCloseBtn.Text = "DeviceOpen";
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (OpenCloseBtn.Text == "DeviceClose")//現在オープン中であれば
            {
                Timer1.Enabled = false; //タイマー停止
                TUSBSIN.Tusbs02in_Device_Close(DevId);
            }
        }
    }
}
